## drbd8 8.3.2

=== drbd/Makefile ===
# makefile for drbd for linux 2.4 // 2.6
#
# By Lars Ellenberg.
#
# drbd is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# drbd is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with drbd; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
#

# usage: make [ KDIR=/path/to/kernel/source ]
#
# this file is read twice:
# the first invocation calls out to the toplevel Makefile in the
# kernel source tree, which then in turn will call this file again
# as subdir Makefile, with all appropriate vars and macros set.
#
# note: if you get strange make errors when ARCH=um, you
# probably need to "make mrproper" in the KDIR first...

# since 2.6.16, KERNELRELEASE may be empty,
# e.g. when building agains some (broken?) linux-header package.
# Lets test on PATCHLEVEL, that won't change too soon...

ifneq ($(PATCHLEVEL),)
  ifneq ($(VERSION),2)
    $(error "won't compile with this kernel version")
  endif
  ifneq ($(PATCHLEVEL),6)
    $(error "won't compile with this kernel version")
  endif

  CONFIG_BLK_DEV_DRBD := m
  CONFIG_DRBD_TRACE := $(shell test $${SUBLEVEL} -ge 30 && echo m || echo n)

  include $(DRBDSRC)/Makefile-2.6

  override EXTRA_CFLAGS += -I$(DRBDSRC)
  # remember KERNELRELEASE for install target
  # .kernelversion can be included in Makefile as well as
  # sourced from shell
  $(shell echo -e "VERSION=$(VERSION)\n"             \
                  "PATCHLEVEL=$(PATCHLEVEL)\n"       \
                  "SUBLEVEL=$(SUBLEVEL)\n"           \
                  "EXTRAVERSION=$(EXTRAVERSION)\n"   \
                  "LOCALVERSION=$(LOCALVERSION)\n"   \
                  "KERNELRELEASE=$(KERNELRELEASE)\n" \
                  "KERNELVERSION=$(KERNELVERSION)"   \
          > $(DRBDSRC)/.drbd_kernelrelease.new       \
   )
else
  # called from command line in current directory

  # for some reason some of the commands below only work correctly in bash,
  # and not in e.g. dash. I'm too lazy to fix it to be compatible.
  SHELL=/bin/bash

  DRBDSRC := $(shell pwd)
  export DRBDSRC

  # to be overridden on command line:
  PREFIX := /
  ifeq ($(wildcard ../build-for-uml),../build-for-uml)
    #### for Philipp's convenience :)
    ARCH_UM := "ARCH=um"
    KDIR := /usr/src/linux-um
  else
    KDIR := /lib/modules/$(shell uname -r)/build
  endif

  KDIR_Makefile_PATCHLEVEL = $(shell test -e $(KDIR)/Makefile && grep "^PATCHLEVEL = " $(KDIR)/Makefile | cut -d " " -f 3)
  ifneq ($(findstring $(KDIR_Makefile_PATCHLEVEL),12345),)
    $(error "won't compile with this kernel version")
  endif

  .PHONY: drbd.o default all greeting clean kbuild install dep tags

  drbd.o: greeting kbuild
  default: drbd.o
  all:     drbd.o

  greeting:
	@echo "" ;\
	echo "    Calling toplevel makefile of kernel source tree, which I believe is in" ;\
	echo "    KDIR=$(KDIR)" ; \
	echo "";
	@if ! test -e $(KDIR)/Makefile ; then \
		echo -e "    SORRY, kernel makefile not found. You need to tell me a correct KDIR!\n" ;\
		false;\
	fi

.PHONY: drbd_buildtag.c

  drbd_buildtag.c:
	@is_tarball=`test -e ../.git/. && echo false || echo true`;\
	set -e; exec > $@.new;							\
	echo -e "/* automatically generated. DO NOT EDIT. */";			\
	echo -e "#include <linux/drbd.h>";					\
	echo -e "const char *drbd_buildtag(void)\n{";				\
	if $$is_tarball; then							\
	  if ! test -e $@ ; then 						\
	  	echo >&2 "your DRBD source tree is broken. unpack again.";	\
		exit 1;								\
	  fi;									\
	  grep return $@ ;							\
	else									\
	  GITHEAD=$$(git rev-parse HEAD);					\
	  GITDIFF=$$(cd .. && git diff --name-only HEAD | tr -s '\t\n' '  ' |	\
	  	sed -e 's/^/ /;s/ *$$//');					\
	  echo -e "\treturn \"GIT-hash: $$GITHEAD$$GITDIFF\"";	 		\
	fi ;									\
	echo -e "\t\t\" build by $$USER@$$HOSTNAME, `date "+%F %T"`\";\n}";	\
	mv --force $@.new $@

  kbuild: drbd_buildtag.c
	@rm -f .drbd_kernelrelease*
	-test -f ../scripts/adjust_drbd_config_h.sh && \
	 KDIR=$(KDIR) O=$(O) $(SHELL) ../scripts/adjust_drbd_config_h.sh
    # previous to 2.6.6 (suse: 2.6.5-dunno), this should be:
	$(MAKE) -C $(KDIR) SUBDIRS=$(DRBDSRC) $(ARCH_UM) modules
# $(MAKE) -C $(KDIR) M=$(DRBDSRC) $(ARCH_UM) modules
	-mv .drbd_kernelrelease.new .drbd_kernelrelease
	@echo -n "Memorizing module configuration ... "
	@config=$$( (for x in $(KDIR)/.config $(O)/.config ; do \
	       if test -e $$x ; then echo $$x ; exit 0; fi ; \
	       done; echo $(KDIR)/.config) | sed -e 's,//,/,g') ; \
	{ echo -e "#\n# drbd.o was compiled with"          ; \
	  echo "#  `gcc -v 2>&1 | tail -1`"                 ; \
	  echo "# against this kernelrelease:"              ; \
	  sed 's/^/#  /' .drbd_kernelrelease                ; \
	  echo    "# kernel .config from"                   ; \
	  echo -n "#  $$config"                      ; \
	  test -L "$${config%/.config}" && echo "	alias"   &&           \
	  echo "#  $$(readlink $${config%/.config})/.config" || echo "" ; \
	  echo -e "# follows\n#\n"                          ; \
	  cat $$config ; } | gzip > .kernel.config.gz
	@echo "done."

  clean:
	rm -rf .tmp_versions
	rm -f *.[oas] *.ko .*.cmd .*.d .*.tmp *.mod.c .*.flags .depend .kernel*

  distclean: clean
	@if git show HEAD:drbd/linux/drbd_config.h > linux/drbd_config.h.tmp \
	&& ! diff -s -U0 linux/drbd_config.h.tmp linux/drbd_config.h ; then \
		mv linux/drbd_config.h.tmp linux/drbd_config.h ; \
	else \
		rm -f linux/drbd_config.h.tmp ; \
	fi

  tags:
	ctags -R -I__initdata,__exitdata,__acquires,__releases \
		-I __must_hold,__protected_by,__protected_read_by,__protected_write_by \
		-I BIO_ENDIO_ARGS

  ifneq ($(wildcard .drbd_kernelrelease),)
    # for VERSION, PATCHLEVEL, SUBLEVEL, EXTRAVERSION, KERNELRELEASE
    include .drbd_kernelrelease
    MODOBJ := drbd.ko
    MODSUBDIR := kernel/drivers/block
    LINUX := $(wildcard /lib/modules/$(KERNELRELEASE)/build)

    install:
	@if ! [ -e $(MODOBJ) ] ; then \
	  echo "No $(MODOBJ): nothing to install??"; false ; \
	fi
# install -d $(PREFIX)/var/lib/drbd
	install -d $(PREFIX)/lib/modules/$(KERNELRELEASE)/$(MODSUBDIR)
	install -m 644 $(MODOBJ) $(PREFIX)/lib/modules/$(KERNELRELEASE)/$(MODSUBDIR)
    ifeq ($(PREFIX),/)
      ifeq ($(shell uname -r),$(KERNELRELEASE))
	/sbin/depmod -a || /sbin/depmod -e $(MODOBJ) 2>&1 >/dev/null || true
      else
	[ -e $(LINUX)/System.map ] && \
	   /sbin/depmod -F $(LINUX)/System.map -e ./$(MODOBJ) 2>&1 >/dev/null || true
      endif
    endif
  else
    install:
	@echo "No .drbd_kernelrelease found. Do you need to 'make' the module first?"
	@false
  endif

  depmod:
	[ -e $(KDIR)/System.map ] && [ -e ./$(MODOBJ) ] && \
	   /sbin/depmod -F $(KDIR)/System.map -n -e ./$(MODOBJ) # 2>&1 >/dev/null
endif

=== scripts/Makefile ===
# Makefile for scripts
#
# This file is part of DRBD by Philipp Reisner & Lars Ellenberg.
#
# Copright 2001-2008 LINBIT Information Technologies
# Philipp Reisner, Lars Ellenberg
#
# drbd is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# drbd is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with drbd; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
#
# for Debian:
#   update-rc.d drbd defaults 70 08
#

SCRIPT=drbd
DIST            :=$(strip \
  $(if $(wildcard /etc/gentoo-release),gentoo,\
  $(if $(wildcard /etc/redhat-release),redhat,\
  $(if $(wildcard /etc/slackware-version),slackware,\
  $(if $(wildcard /etc/debian_version),debian,\
  $(if $(wildcard /sbin/rcsyslog),suselike,))))))

INST_COMPLETION := 1
INST_RHCS := 0

ifeq ($(DIST),slackware)
  INITD=$(PREFIX)/etc/rc.d/
  INST_COMPLETION := 0
endif

ifeq ($(DIST),gentoo)
  INITD=$(PREFIX)/etc/init.d/
  SCRIPT=drbd.gentoo
endif

ifeq ($(DIST),redhat)
  INITD=$(PREFIX)/etc/rc.d/init.d/
  INST_COMPLETION := 0
  INST_RHCS := 1
endif

ifeq ($(DIST),redhat)
  ifeq ($(shell if grep -q XenServer /etc/redhat-release; then echo xenserver; fi),xenserver)
    INST_COMPLETION := 1
    INST_RHCS := 0
  endif
endif

ifeq ($(INITD),)
   INITD=$(PREFIX)/etc/init.d/
   $(warning No special distribution INITD)
   $(warning setting INITD=$(INITD) according to LSB)
endif

ifeq ($(DIST),suselike)
   COMPLETION=drbdadm.sh
else
   COMPLETION=drbdadm
endif

all:

install: install-most install-udev-rules

install-most:
	mkdir -p $(PREFIX)/etc/ha.d/resource.d
	install -d $(INITD)
	install -m 755 $(SCRIPT) $(INITD)drbd
	@ if [ ! -e $(PREFIX)/etc/drbd.conf ]; then \
		install -d $(PREFIX)/etc/; \
		install -m 644 drbd.conf $(PREFIX)/etc/; \
	fi
	install -m 755 drbddisk $(PREFIX)/etc/ha.d/resource.d
	install -m 755 drbdupper $(PREFIX)/etc/ha.d/resource.d
	mkdir -p $(PREFIX)/usr/lib/ocf/resource.d/linbit
	install -m 755 drbd.ocf $(PREFIX)/usr/lib/ocf/resource.d/linbit/drbd
	install -d $(PREFIX)/usr/lib/drbd
	install -m 755 outdate-peer.sh $(PREFIX)/usr/lib/drbd
	install -m 755 crm-fence-peer.sh $(PREFIX)/usr/lib/drbd
	install -m 755 snapshot-resync-target-lvm.sh $(PREFIX)/usr/lib/drbd
	install -m 755 notify.sh $(PREFIX)/usr/lib/drbd
	( set -e ; cd $(PREFIX)/usr/lib/drbd ;\
	  ln -sf crm-fence-peer.sh crm-unfence-peer.sh ;\
	  ln -sf snapshot-resync-target-lvm.sh unsnapshot-resync-target-lvm.sh ;\
	  ln -sf notify.sh notify-split-brain.sh ;\
	  ln -sf notify.sh notify-io-error.sh ;\
	  ln -sf notify.sh notify-pri-on-incon-degr.sh ;\
	  ln -sf notify.sh notify-pri-lost.sh ;\
	  ln -sf notify.sh notify-pri-lost-after-sb.sh ;\
	  ln -sf notify.sh notify-emergency-reboot.sh ;\
	  ln -sf notify.sh notify-emergency-shutdown.sh ;\
	  ln -sf notify.sh notify-out-of-sync.sh; )
	mkdir -p $(PREFIX)/etc/xen/scripts
	install -m 755 block-drbd $(PREFIX)/etc/xen/scripts
	mkdir -p $(PREFIX)/etc/udev/rules.d
ifneq ($(INST_COMPLETION),1)
	mkdir -p $(PREFIX)/etc/bash_completion.d
	install -m 644 drbdadm.bash_completion $(PREFIX)/etc/bash_completion.d/$(COMPLETION)
endif
	install -d $(PREFIX)/usr/sbin
	# strip .pl on install,
	# at some point we might reimplement similar functionality in non-perl
	install -m 755 drbd-overview.pl $(PREFIX)/usr/sbin/drbd-overview
ifeq ($(DIST),suselike)
	ln -sf ../etc/init.d/drbd $(PREFIX)/sbin/rcdrbd
endif
ifeq ($(INST_RHCS),1)
	mkdir -p $(PREFIX)/usr/share/cluster
	install -m 755 drbd.sh.rhcs $(PREFIX)/usr/share/cluster/drbd.sh
	install -m 644 drbd.metadata.rhcs $(PREFIX)/usr/share/cluster/drbd.metadata
endif
	@ echo
	@ echo "Don't forget to run update-rc.d or chkconfig"

# more install
# only install the udev rules file when udev is determined to be new enough.
# udevadm was introduced in 117, which is ok.
# if udevadm is not there, we still may work.
# try to ask the package data base (rpm/deb) for the udev version.
# IMPORT was introduced in 059.
# ETCH is 105, RHEL5 is 095, SLES10 is 085. test on >= 085.
#
# may be overridden from build environment,
# e.g. if you build in some changeroot without access to the package database,
# or without udev installed.
# 
install-udev-rules:
	disable=.disabled ; \
	v=$$(udevadm version 2>/dev/null) || \
	v=$$(rpm -q --qf '%{VERSION}' udev 2>/dev/null) || \
	v=$$(dpkg-query -W -f '$${Version}' udev 2>/dev/null); \
	v=$${v##*.} ; v=$${v%%-*} ; v=$${v#0} ; \
	if [ -n "$$DRBD_ENABLE_UDEV" ] ; then \
		disable="" ; \
	else case "$$v" in \
	"") :;; *[!0-9]*) :;; *) \
		if [ "$$v" -ge 85 ]; then \
			disable=""; \
		fi ;; \
	esac; fi ; \
	install -m 644 drbd.rules $(PREFIX)/etc/udev/rules.d/65-drbd.rules$$disable

clean:
	rm -f *~
	rm -f datadisk

distclean: clean

uninstall:
	rm $(INITD)drbd
	rm $(PREFIX)/etc/ha.d/resource.d/drbddisk
	rm $(PREFIX)/etc/ha.d/resource.d/drbdupper
	rm $(PREFIX)/etc/xen/scripts/block-drbd
	rm $(PREFIX)/etc/bash_completion.d/$(COMPLETION)
	! test -L $(PREFIX)/sbin/rcdrbd || rm $(PREFIX)/sbin/rcdrbd

=== user/Makefile ===
# Makefile for drbd.o
#
# This file is part of DRBD by Philipp Reisner and Lars Ellenberg.
#
# drbd is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# drbd is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with drbd; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
#

KDIR := /lib/modules/$(shell uname -r)/build

CC = gcc
OPTFLAGS = -O1
CFLAGS = $(OPTFLAGS) -c -W -Wall -I../drbd
# for the netlink connector stuff <linux/connector.h>:
drbdsetup: CFLAGS += -I$(KDIR)/include

drbdadm-obj = drbdadm_scanner.o drbdadm_parser.o drbdadm_main.o \
	      drbdadm_adjust.o drbdtool_common.o drbdadm_usage_cnt.o \
	      drbd_buildtag.o drbdadm_minor_table.o

drbdsetup-obj = drbdsetup.o drbdtool_common.o drbd_buildtag.o \
	        drbd_strings.o

drbdmeta-obj = drbdmeta.o drbdmeta_scanner.o drbdtool_common.o drbd_buildtag.o

all: drbdadm drbdmeta drbdsetup

drbd_buildtag.c: ../drbd/drbd_buildtag.c
	cp $^ $@

drbd_strings.c: ../drbd/drbd_strings.c
	cp $^ $@

drbdadm: $(drbdadm-obj)
	$(CC) -o $@ $^

# for debugging:
# 	LANG=C LC_ALL=C flex -d -b -s -odrbdadm_scanner.c drbdadm_scanner.fl

drbdadm_scanner.c: drbdadm_scanner.fl drbdadm_parser.h
	flex -s -odrbdadm_scanner.c drbdadm_scanner.fl

drbdmeta_scanner.c: drbdmeta_scanner.fl drbdmeta_parser.h
	flex -s -odrbdmeta_scanner.c drbdmeta_scanner.fl

drbdsetup: $(drbdsetup-obj)
	$(CC) -o $@ $^

drbdmeta: $(drbdmeta-obj)
	$(CC) -o $@ $^

drbdmeta_unfinished_rewrite: CFLAGS += -fno-strict-aliasing
drbdmeta_unfinished_rewrite: drbdmeta_unfinished_rewrite.o drbdmeta_scanner.o drbdtool_common.o drbd_buildtag.o
	$(CC) -o $@ $^

clean:
	rm -f drbdadm_scanner.c drbdmeta_scanner.c
	rm -f drbdsetup drbdadm drbdmeta drbdmeta_unfinished_rewrite *.o
	rm -f drbd_buildtag.c drbd_strings.c
	rm -f *~

distclean: clean

install:
	install -d $(PREFIX)/sbin/
	if getent group haclient > /dev/null 2> /dev/null ; then	\
		install -g haclient -m 4750 drbdsetup $(PREFIX)/sbin/ ;	\
		install -g haclient -m 4750 drbdmeta $(PREFIX)/sbin/ ;	\
		install -m 755 drbdadm $(PREFIX)/sbin/ ;		\
	else								\
		install -m 755 drbdsetup $(PREFIX)/sbin/ ;		\
		install -m 755 drbdmeta $(PREFIX)/sbin/ ;		\
		install -m 755 drbdadm $(PREFIX)/sbin/ ; 		\
	fi
	mkdir -p $(PREFIX)/var/lib/drbd

uninstall:
	rm -f $(PREFIX)/sbin/drbdsetup
	rm -f $(PREFIX)/sbin/drbdadm

###dependencies
drbdsetup.o:       drbdtool_common.h ../drbd/linux/drbd_limits.h
drbdsetup.o:       ../drbd/linux/drbd_tag_magic.h ../drbd/linux/drbd.h
drbdsetup.o:       ../drbd/linux/drbd_config.h ../drbd/linux/drbd_nl.h
drbdsetup.o:       unaligned.h
drbdtool_common.o: drbdtool_common.h
drbdadm_main.o:    drbdtool_common.h drbdadm.h
drbdadm_adjust.o:  drbdtool_common.h drbdadm.h
drbdadm_parser.o:  drbdtool_common.h drbdadm.h ../drbd/linux/drbd_limits.h
drbdadm_scanner.o:                   drbdadm.h               drbdadm_parser.h
drbdsetup.o:       drbdtool_common.h           ../drbd/linux/drbd_limits.h
drbdmeta.o:        drbdtool_common.h drbd_endian.h
drbdmeta_unfinished_rewrite.o:        drbdtool_common.h drbd_endian.h
drbdadm_usage_cnt.o: drbdadm.h drbd_endian.h

## drbd8 8.3.3

=== documentation/Makefile ===
# Makefile in documentation directory
#
# This file is part of DRBD by Philipp Reisner and Lars Ellenberg.
#
# drbd is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# drbd is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with drbd; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

MANPAGES       := drbdsetup.8 drbd.conf.5 drbd.8 drbdadm.8 drbddisk.8 drbdmeta.8
SOURCES        := $(wildcard *.xml)

STYLESHEET_PREFIX ?= http://docbook.sourceforge.net/release/xsl/current
MANPAGES_STYLESHEET ?= $(STYLESHEET_PREFIX)/manpages/docbook.xsl
HTML_STYLESHEET ?= $(STYLESHEET_PREFIX)/xhtml/docbook.xsl
FO_STYLESHEET ?= $(STYLESHEET_PREFIX)/fo/docbook.xsl

XSLTPROC_MANPAGES_OPTIONS ?= --xinclude
XSLTPROC_HTML_OPTIONS ?= --xinclude
XSLTPROC_FO_OPTIONS ?= --xinclude

all:
	@echo "To (re)make the documentation: make doc"

clean:
	@echo "To clean the documentation: make doc-clean"

doc:	man

doc-clean: distclean


####### Implicit rules

.SUFFIXES: .sgml .5 .8 .html .pdf .ps

%.5 %.8: %.xml 
	xsltproc \
	$(XSLTPROC_MANPAGES_OPTIONS) \
	$(MANPAGES_STYLESHEET) $<

%.html: %.xml
	xsltproc -o $@ \
	$(XSLTPROC_HTML_OPTIONS) \
	$(HTML_STYLESHEET) $<

%.fo: %.xml
	xsltproc -o $@ \
	$(XSLTPROC_FO_OPTIONS) \
	$(FO_STYLESHEET) $<

distclean:
	rm -f *.[58] manpage.links manpage.refs *~ manpage.log
	rm -f *.ps.gz *.pdf *.ps *.html pod2htm*

#######

man:	$(MANPAGES)

install:
	@ok=true; for f in $(MANPAGES) ; \
		do [ -e $$f ] || { echo $$f missing ; ok=false; } ; \
	done ; $$ok
	set -e; for f in $(MANPAGES) ; do \
		s=$${f##*.}; \
		install -v -D -m 644 $$f $(PREFIX)/usr/share/man/man$$s/$$f ; \
	done

uninstall:
	@ set -e; for f in $(MANPAGES) ; do \
		s=$${f##*.}; \
		rm -v $(PREFIX)/usr/share/man/man$$s/$$f ; \
	done

html:	$(SOURCES:.xml=.html)

pdf:	$(SOURCES:.xml=.pdf)

ps:	$(SOURCES:.xml=.ps)

=== drbd/Makefile ===
--- 
+++ 
@@ -69,12 +69,21 @@
 
   # to be overridden on command line:
   PREFIX := /
-  ifeq ($(wildcard ../build-for-uml),../build-for-uml)
+  ifneq ($(wildcard ../build-for-uml),)
     #### for Philipp's convenience :)
     ARCH_UM := "ARCH=um"
     KDIR := /usr/src/linux-um
   else
-    KDIR := /lib/modules/$(shell uname -r)/build
+    ifeq ($(wildcard /lib/modules/$(shell uname -r)/source),)
+      KDIR := /lib/modules/$(shell uname -r)/build
+    else
+      KDIR := /lib/modules/$(shell uname -r)/source
+      ifneq ("$(origin KDIR)", "command line")
+        ifneq ($(wildcard /lib/modules/$(shell uname -r)/build),)
+          O := /lib/modules/$(shell uname -r)/build
+        endif
+      endif
+    endif
   endif
 
   KDIR_Makefile_PATCHLEVEL = $(shell test -e $(KDIR)/Makefile && grep "^PATCHLEVEL = " $(KDIR)/Makefile | cut -d " " -f 3)
@@ -126,7 +135,7 @@
 	-test -f ../scripts/adjust_drbd_config_h.sh && \
 	 KDIR=$(KDIR) O=$(O) $(SHELL) ../scripts/adjust_drbd_config_h.sh
     # previous to 2.6.6 (suse: 2.6.5-dunno), this should be:
-	$(MAKE) -C $(KDIR) SUBDIRS=$(DRBDSRC) $(ARCH_UM) modules
+	$(MAKE) -C $(KDIR)  $(if $(O),O=$(O),) SUBDIRS=$(DRBDSRC) $(ARCH_UM) modules
 # $(MAKE) -C $(KDIR) M=$(DRBDSRC) $(ARCH_UM) modules
 	-mv .drbd_kernelrelease.new .drbd_kernelrelease
 	@echo -n "Memorizing module configuration ... "
@@ -194,3 +203,9 @@
 	[ -e $(KDIR)/System.map ] && [ -e ./$(MODOBJ) ] && \
 	   /sbin/depmod -F $(KDIR)/System.map -n -e ./$(MODOBJ) # 2>&1 >/dev/null
 endif
+
+spell:
+	for f in $(wildcard *.c); do \
+	 	aspell --save-repl --dont-backup --personal=./../documentation/aspell.en.per check $$f; \
+	done
+

=== scripts/Makefile ===
--- 
+++ 
@@ -104,7 +104,7 @@
 	mkdir -p $(PREFIX)/etc/xen/scripts
 	install -m 755 block-drbd $(PREFIX)/etc/xen/scripts
 	mkdir -p $(PREFIX)/etc/udev/rules.d
-ifneq ($(INST_COMPLETION),1)
+ifeq ($(INST_COMPLETION),1)
 	mkdir -p $(PREFIX)/etc/bash_completion.d
 	install -m 644 drbdadm.bash_completion $(PREFIX)/etc/bash_completion.d/$(COMPLETION)
 endif

=== user/Makefile ===
--- 
+++ 
@@ -22,8 +22,6 @@
 CC = gcc
 OPTFLAGS = -O1
 CFLAGS = $(OPTFLAGS) -c -W -Wall -I../drbd
-# for the netlink connector stuff <linux/connector.h>:
-drbdsetup: CFLAGS += -I$(KDIR)/include
 
 drbdadm-obj = drbdadm_scanner.o drbdadm_parser.o drbdadm_main.o \
 	      drbdadm_adjust.o drbdtool_common.o drbdadm_usage_cnt.o \
@@ -89,6 +87,11 @@
 	rm -f $(PREFIX)/sbin/drbdsetup
 	rm -f $(PREFIX)/sbin/drbdadm
 
+spell:
+	for f in drbdadm_adjust.c drbdadm_main.c drbdadm_parser.c drbdadm_usage_cnt.c drbdmeta.c drbdsetup.c drbdtool_common.c; do \
+	 	aspell --save-repl --dont-backup --personal=./../documentation/aspell.en.per check $$f; \
+	done
+
 ###dependencies
 drbdsetup.o:       drbdtool_common.h ../drbd/linux/drbd_limits.h
 drbdsetup.o:       ../drbd/linux/drbd_tag_magic.h ../drbd/linux/drbd.h

## drbd8 8.3.4

=== drbd/Makefile ===
--- 
+++ 
@@ -182,10 +182,10 @@
 	@if ! [ -e $(MODOBJ) ] ; then \
 	  echo "No $(MODOBJ): nothing to install??"; false ; \
 	fi
-# install -d $(PREFIX)/var/lib/drbd
-	install -d $(PREFIX)/lib/modules/$(KERNELRELEASE)/$(MODSUBDIR)
-	install -m 644 $(MODOBJ) $(PREFIX)/lib/modules/$(KERNELRELEASE)/$(MODSUBDIR)
-    ifeq ($(PREFIX),/)
+# install -d $(DESTDIR)/var/lib/drbd
+	install -d $(DESTDIR)/lib/modules/$(KERNELRELEASE)/$(MODSUBDIR)
+	install -m 644 $(MODOBJ) $(DESTDIR)/lib/modules/$(KERNELRELEASE)/$(MODSUBDIR)
+    ifeq ($(DESTDIR),/)
       ifeq ($(shell uname -r),$(KERNELRELEASE))
 	/sbin/depmod -a || /sbin/depmod -e $(MODOBJ) 2>&1 >/dev/null || true
       else

## drbd8 8.3.7

=== drbd/Makefile ===
--- 
+++ 
@@ -26,6 +26,10 @@
 #
 # note: if you get strange make errors when ARCH=um, you
 # probably need to "make mrproper" in the KDIR first...
+
+# The destination "root" directory. Meant to be overridden by
+# packaging scripts.
+DESTDIR ?= /
 
 # since 2.6.16, KERNELRELEASE may be empty,
 # e.g. when building agains some (broken?) linux-header package.
@@ -182,7 +186,6 @@
 	@if ! [ -e $(MODOBJ) ] ; then \
 	  echo "No $(MODOBJ): nothing to install??"; false ; \
 	fi
-# install -d $(DESTDIR)/var/lib/drbd
 	install -d $(DESTDIR)/lib/modules/$(KERNELRELEASE)/$(MODSUBDIR)
 	install -m 644 $(MODOBJ) $(DESTDIR)/lib/modules/$(KERNELRELEASE)/$(MODSUBDIR)
     ifeq ($(DESTDIR),/)

## drbd8 8.3.9

=== drbd/Makefile ===
--- 
+++ 
@@ -159,7 +159,7 @@
 	@echo "done."
 
   clean:
-	rm -rf .tmp_versions
+	rm -rf .tmp_versions Module.markers Module.symvers modules.order
 	rm -f *.[oas] *.ko .*.cmd .*.d .*.tmp *.mod.c .*.flags .depend .kernel*
 
   distclean: clean

## drbd8 8.3.11

=== drbd/Makefile ===
--- 
+++ 
@@ -36,19 +36,20 @@
 # Lets test on PATCHLEVEL, that won't change too soon...
 
 ifneq ($(PATCHLEVEL),)
+ ifneq ($(VERSION),3)
   ifneq ($(VERSION),2)
     $(error "won't compile with this kernel version")
   endif
   ifneq ($(PATCHLEVEL),6)
     $(error "won't compile with this kernel version")
   endif
+ endif
 
   CONFIG_BLK_DEV_DRBD := m
-  CONFIG_DRBD_TRACE := $(shell test $${SUBLEVEL} -ge 30 && echo m || echo n)
-
-  include $(DRBDSRC)/Makefile-2.6
-
-  override EXTRA_CFLAGS += -I$(DRBDSRC)
+  CONFIG_DRBD_TRACE := n
+
+  include $(src)/Makefile-2.6
+
   # remember KERNELRELEASE for install target
   # .kernelversion can be included in Makefile as well as
   # sourced from shell
@@ -59,7 +60,7 @@
                   "LOCALVERSION=$(LOCALVERSION)\n"   \
                   "KERNELRELEASE=$(KERNELRELEASE)\n" \
                   "KERNELVERSION=$(KERNELVERSION)"   \
-          > $(DRBDSRC)/.drbd_kernelrelease.new       \
+          > $(src)/.drbd_kernelrelease.new       \
    )
 else
   # called from command line in current directory
@@ -69,7 +70,6 @@
   SHELL=/bin/bash
 
   DRBDSRC := $(shell pwd)
-  export DRBDSRC
 
   # to be overridden on command line:
   PREFIX := /
@@ -114,22 +114,25 @@
 .PHONY: drbd_buildtag.c
 
   drbd_buildtag.c:
-	@is_tarball=`test -e ../.git/. && echo false || echo true`;\
-	set -e; exec > $@.new;							\
+	@set -e; exec > $@.new;							\
 	echo -e "/* automatically generated. DO NOT EDIT. */";			\
 	echo -e "#include <linux/drbd.h>";					\
 	echo -e "const char *drbd_buildtag(void)\n{";				\
-	if $$is_tarball; then							\
-	  if ! test -e $@ ; then 						\
-	  	echo >&2 "your DRBD source tree is broken. unpack again.";	\
+	if test -e ../.git && GITHEAD=$$(git rev-parse HEAD); then		\
+		GITDIFF=$$(cd .. && git diff --name-only HEAD |			\
+			tr -s '\t\n' '  ' |					\
+			sed -e 's/^/ /;s/ *$$//');				\
+		echo -e "\treturn \"GIT-hash: $$GITHEAD$$GITDIFF\"";		\
+	elif ! test -e $@ ; then						\
+		echo >&2 "$@ not found.";					\
+		test -e ../.git &&						\
+		>&2 printf "%s\n"						\
+			"git did not work, but this looks like a git checkout?"	\
+			"Install git and try again." ||				\
+		echo >&2 "Your DRBD source tree is broken. Unpack again.";	\
 		exit 1;								\
-	  fi;									\
-	  grep return $@ ;							\
 	else									\
-	  GITHEAD=$$(git rev-parse HEAD);					\
-	  GITDIFF=$$(cd .. && git diff --name-only HEAD | tr -s '\t\n' '  ' |	\
-	  	sed -e 's/^/ /;s/ *$$//');					\
-	  echo -e "\treturn \"GIT-hash: $$GITHEAD$$GITDIFF\"";	 		\
+		grep return $@ ;						\
 	fi ;									\
 	echo -e "\t\t\" build by $$USER@$$HOSTNAME, `date "+%F %T"`\";\n}";	\
 	mv --force $@.new $@
@@ -137,7 +140,7 @@
   kbuild: drbd_buildtag.c
 	@rm -f .drbd_kernelrelease*
 	-test -f ../scripts/adjust_drbd_config_h.sh && \
-	 KDIR=$(KDIR) O=$(O) $(SHELL) ../scripts/adjust_drbd_config_h.sh
+		KDIR=$(KDIR) O=$(O) $(SHELL) ../scripts/adjust_drbd_config_h.sh
     # previous to 2.6.6 (suse: 2.6.5-dunno), this should be:
 	$(MAKE) -C $(KDIR)  $(if $(O),O=$(O),) SUBDIRS=$(DRBDSRC) $(ARCH_UM) modules
 # $(MAKE) -C $(KDIR) M=$(DRBDSRC) $(ARCH_UM) modules
@@ -179,7 +182,7 @@
     # for VERSION, PATCHLEVEL, SUBLEVEL, EXTRAVERSION, KERNELRELEASE
     include .drbd_kernelrelease
     MODOBJ := drbd.ko
-    MODSUBDIR := kernel/drivers/block
+    MODSUBDIR := updates
     LINUX := $(wildcard /lib/modules/$(KERNELRELEASE)/build)
 
     install:

=== debian/changelog ===
drbd8 (2:8.3.11-3~bpo60+1) squeeze-backports; urgency=low

  * Rebuild for squeeze-backports.

 -- Martin Loschwitz <madkiss@debian.org>  Thu, 19 Apr 2012 14:59:27 +0000

drbd8 (2:8.3.11-3) unstable; urgency=low

  * Install udev rule into /lib/udev/rules.d instead of /etc
  * Don't invoke make with '-' except for drbd/Makefile
  * Don't complain in prerm about unknown argument upgrade
  * Architecture changed to linux-any
  * build-arch: depend on configure (Closes: #666345)

 -- Philipp Hug <debian@hug.cx>  Fri, 30 Mar 2012 18:52:55 +0200

drbd8 (2:8.3.11-2) unstable; urgency=low

  * Don't create /dev/drbdX in postinst (Closes: #656143)
  * Install drbd.conf.example (Closes: #613872)
  * Define init script as interactive (Closes: #613654)
  * Suggest to use dpkg-statoverride (Closes: #519187)

 -- Philipp Hug <debian@hug.cx>  Tue, 20 Mar 2012 14:52:42 +0100

drbd8 (2:8.3.11-1) unstable; urgency=low

  * New upstream release.
  * Clean some more files
  * Switch to dpkg-source 3.0 (quilt) format
  * Delete config.log, config.status
  * Build-Depend on xsltproc (for documentation) and git (for build-tags)

 -- Philipp Hug <debian@hug.cx>  Tue, 20 Mar 2012 12:12:57 +0100

drbd8 (2:8.3.10-1) unstable; urgency=low

  * New upstream release. (Closes: #635329)
  * Moved to git.debian.org for package maintenance.
  * Removed dpatch

 -- Philipp Hug <debian@hug.cx>  Thu, 28 Jul 2011 16:42:04 +0200

drbd8 (2:8.3.9-1) unstable; urgency=low

  * New upstream release.

 -- Norbert Tretkowski <norbert@tretkowski.de>  Thu, 13 Jan 2011 15:36:21 +0100

drbd8 (2:8.3.8.1-1) unstable; urgency=low

  * New upstream release. (closes: #590814)
  * Remove no longer required files.
  * Drop docbook-utils from build-dependencies.
  * Drop architecture independant parts.

 -- Norbert Tretkowski <norbert@tretkowski.de>  Sun, 29 Aug 2010 15:57:31 +0200

drbd8 (2:8.3.7-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Use the init script of the 8.3.8.1 release fixing broken LSB headers.
    (closes: #576901)

 -- Alexander Reichle-Schmehl <tolimar@debian.org>  Thu, 15 Jul 2010 14:03:40 +0200

drbd8 (2:8.3.7-2) unstable; urgency=low

  * Drop -source package, now that DRBD is part of the Linux mainline kernel.
    (closes: #573514, #580184)

 -- Norbert Tretkowski <norbert@tretkowski.de>  Thu, 10 Jun 2010 20:29:40 +0200

drbd8 (2:8.3.7-1) unstable; urgency=low

  * New upstream release.
    + Correct dependencies in init.d script. (closes: 547566, #563783)
  * Acknowledge NMU of 2:8.3.4-1.1, thanks Iustin for taking care of this!
    (closes: #499516)
  * Ship scripts/adjust_drbd_config_h.sh and run it before building the kernel
    module. (closes: #551479, #552439)

 -- Norbert Tretkowski <norbert@tretkowski.de>  Mon, 18 Jan 2010 16:29:43 +0100

drbd8 (2:8.3.4-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix watch file
  * No longer stops the drbd resources on upgrades of the drbd8-utils
    package, since this is not needed and shutdowns must be done by the
    administrator. (closes: #499516)

 -- Iustin Pop <iusty@k1024.org>  Fri, 13 Nov 2009 19:58:29 +0100

drbd8 (2:8.3.4-1) unstable; urgency=low

  * New upstream release.

 -- Norbert Tretkowski <norbert@tretkowski.de>  Fri, 16 Oct 2009 09:18:11 +0200

drbd8 (2:8.3.3~rc3-1) experimental; urgency=low

  * New upstream release candidate.

 -- Norbert Tretkowski <norbert@tretkowski.de>  Tue, 29 Sep 2009 21:43:01 +0200

drbd8 (2:8.3.3~rc2-1) experimental; urgency=low

  * New upstream release candidate.

 -- Norbert Tretkowski <norbert@tretkowski.de>  Wed, 16 Sep 2009 19:17:52 +0200

drbd8 (2:8.3.3~rc1-1) experimental; urgency=low

  * New upstream release candidate.

 -- Norbert Tretkowski <norbert@tretkowski.de>  Mon, 31 Aug 2009 11:44:25 +0200

drbd8 (2:8.3.2-3) unstable; urgency=low

  * Drop DKMS support for now, to get the package back into testing. 
    (closes: #537986, #539218, #539219)

 -- Norbert Tretkowski <norbert@tretkowski.de>  Sun, 16 Aug 2009 12:23:59 +0200

drbd8 (2:8.3.2-2) unstable; urgency=low

  * Switch to DKMS, patch from Ante Karamatić (Ubuntu).

 -- Norbert Tretkowski <norbert@tretkowski.de>  Tue, 21 Jul 2009 20:17:47 +0200

drbd8 (2:8.3.2-1) unstable; urgency=low

  * New upstream release.
  * Section of drbd8-source is kernel.

 -- Norbert Tretkowski <norbert@tretkowski.de>  Mon, 06 Jul 2009 21:17:28 +0200

drbd8 (2:8.3.2~rc2-1) unstable; urgency=low

  * New upstream release candidate.

 -- Norbert Tretkowski <norbert@tretkowski.de>  Sat, 27 Jun 2009 16:28:20 +0200

drbd8 (2:8.3.2~rc1-1) unstable; urgency=low

  * New upstream release candidate.
    + Make it compile on Linux 2.6.30. (closes: #533261, #533654)
  * Update Standards-Version to 3.8.2, no changes required.
  * Fix maintainer-script-ignores-errors lintian warning.

 -- Norbert Tretkowski <norbert@tretkowski.de>  Mon, 22 Jun 2009 20:52:22 +0200

drbd8 (2:8.3.1-2) unstable; urgency=medium

  * Added a new patch from Michael Prokop to fix build with kernel 2.6.28 and
    older. (closes: #522891)

 -- Norbert Tretkowski <norbert@tretkowski.de>  Fri, 03 Apr 2009 19:54:44 +0200

drbd8 (2:8.3.1-1) unstable; urgency=low

  * New upstream release.

 -- Norbert Tretkowski <norbert@tretkowski.de>  Fri, 27 Mar 2009 14:16:36 +0100

drbd8 (2:8.3.1~rc2-1) experimental; urgency=low

  * New upstream release candidate.

 -- Norbert Tretkowski <norbert@tretkowski.de>  Thu, 26 Mar 2009 10:52:06 +0100

drbd8 (2:8.3.1~rc1-1) experimental; urgency=low

  * New upstream release candidate.
  * Drop patch 10_lsb-init-script.dpatch, merged upstream.

 -- Norbert Tretkowski <norbert@tretkowski.de>  Tue, 17 Mar 2009 16:38:52 +0100

drbd8 (2:8.3.0-3) unstable; urgency=low

  [ Martin G. Loschwitz ]
  * Sigh. Remove SVN-Files from debian-diff file.

 -- Martin Loschwitz <madkiss@debian.org>  Wed, 11 Mar 2009 17:46:00 +0100

drbd8 (2:8.3.0-2) unstable; urgency=low

  [ Norbert Tretkowski ]
  * Package is now team-maintained.
  * Use dpatch for patch management.


=== debian/control ===
Source: drbd8
Section: admin
Priority: extra
Maintainer: Debian DRBD Maintainers <debian-ha-maintainers@lists.alioth.debian.org>
Uploaders: Norbert Tretkowski <norbert@tretkowski.de>, Martin Loschwitz <madkiss@debian.org>, Philipp Hug <debian@hug.cx>
Build-Depends: debhelper (>= 5), debconf-utils, bison, flex, bzip2, xsltproc, git
Standards-Version: 3.9.1
Homepage: http://www.drbd.org/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-ha/drbd.git
Vcs-Git: git://git.debian.org/git/debian-ha/drbd/

Package: drbd8-utils
Architecture: linux-any
Section: admin
Depends: debconf | debconf-2.0, ${shlibs:Depends}, ${misc:Depends}
Conflicts: drbd-utils
Provides: drbd-utils
Replaces: drbd-utils, drbd
Suggests: heartbeat
Description: RAID 1 over tcp/ip for Linux utilities
 Drbd is a block device which is designed to build high availability
 clusters by providing a virtual shared device which keeps disks in
 nodes synchronised using TCP/IP. This simulates RAID 1 but avoiding
 the use of uncommon hardware (shared SCSI buses or Fibre Channel).
 It is currently limited to fail-over HA clusters.
 .
 This package contains the programs that will control the drbd kernel
 module provided in the Linux kernel.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

#include /usr/share/dpatch/dpatch.make

# This has to be exported to make some magic below work.
export DH_OPTIONS

PACKAGE=drbd8
MA_DIR ?= /usr/share/modass
-include $(MA_DIR)/include/generic.make
-include $(MA_DIR)/include/common-rules.make

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

# module-assistant stuff
MAJOR=$(shell echo $(KVERS) | sed -e 's/\(...\).*/\1/')
ifeq ($(MAJOR),2.6)
KO=k
endif

ifeq ($(DEB_BUILD_ARCH),i386)
ifeq ($(KPKG_ARCH),amd64)
KBUILD_PARAMS := "CROSS_COMPILE=amd64-linux- ARCH=x86_64"
CC=amd64-linux-gcc
endif
endif

kdist_clean:
	dh_clean
	$(MAKE) -C $(KSRC) M=$(CURDIR)/drbd/ clean 

# prep-deb-files rewrites the debian/ files as needed. See RATIONALE for
# details
kdist_config: prep-deb-files
# ... additional kernel specific things to configure...

kdist_configure: kdist_config

binary-modules: prep-deb-files
	dh_testdir
	dh_testroot
	dh_clean -k
	make -C $(KSRC) M=$(CURDIR)/drbd/ modules
	install -m644 -b -D drbd/drbd.$(KO)o $(CURDIR)/debian/$(PKGNAME)/lib/modules/$(KVERS)/kernel/extra/drbd.$(KO)o
	# this is broken, dunno why:
	#make -C $(KSRC) M=$(CURDIR)/drbd/ modules_install INSTALL_MOD_PATH=$(CURDIR)/debian/$(PKGNAME) INSTALL_MOD_DIR=extra/
	dh_installdocs
	dh_installchangelogs
	dh_compress
	dh_fixperms
	dh_installmodules
	dh_installdeb
	dh_gencontrol -- -v$(VERSION)
	dh_md5sums
	dh_builddeb --destdir=$(DEB_DESTDIR)

#Architecture

configure: configure-stamp
configure-stamp:
	./configure --prefix=/usr --localstatedir=/var --sysconfdir=/etc --with-utils --with-udev --with-xen --with-pacemaker --with-rgmanager --with-bashcompletion

build: configure build-arch


build-arch: configure build-arch-stamp
build-arch-stamp:
	dh_testdir
	make
	touch build-arch-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp configure-stamp
	# not possible to fix as there's a bug in drbd/Makefile
	-$(MAKE) -C drbd clean
	-$(MAKE) clean
	[ ! -f scripts/Makefile ] || $(MAKE) -C scripts clean
	[ ! -f benchmark/Makefile ] || $(MAKE) -C benchmark clean
	[ ! -f documentation/Makefile ] || $(MAKE) -C documentation clean
	[ ! -f user/Makefile ] || $(MAKE) -C user clean
	rm -f user/Makefile user/config.h
	rm -f scripts/Makefile
	rm -f documentation/Makefile
	rm -f Makefile
	rm -f config.log config.status

	dh_clean

install: install-arch

install-arch:
	dh_testdir
	dh_testroot
	dh_clean -k -s
	dh_installdirs -s

	$(MAKE) DESTDIR=$(CURDIR)/debian/drbd8-utils/ install
	dh_install --source=debian/drbd8-utils --list-missing -s

	# Move udev rule to /lib/udev/rules.d (Fixes lintian warning)
	mkdir -p $(CURDIR)/debian/drbd8-utils/lib/udev/
	mv $(CURDIR)/debian/drbd8-utils/etc/udev/rules.d $(CURDIR)/debian/drbd8-utils/lib/udev/

# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples
#	dh_installmenu
#	dh_installdebconf
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common

binary: binary-arch
.PHONY: build clean binary-arch binary install install-arch

## drbd8 8.3.13

=== drbd/Makefile ===
--- 
+++ 
@@ -88,11 +88,6 @@
         endif
       endif
     endif
-  endif
-
-  KDIR_Makefile_PATCHLEVEL = $(shell test -e $(KDIR)/Makefile && grep "^PATCHLEVEL = " $(KDIR)/Makefile | cut -d " " -f 3)
-  ifneq ($(findstring $(KDIR_Makefile_PATCHLEVEL),12345),)
-    $(error "won't compile with this kernel version")
   endif
 
   .PHONY: drbd.o default all greeting clean kbuild install dep tags

=== debian/changelog ===
drbd8 (2:8.3.13-2) unstable; urgency=low

  * Integrated NMU
  * Comment-out default handlers for pri-on-incon-degr/pri-lost-after-sb in '/etc/drbd.d/global_common.conf'
  ** Re-enable them if you want to improve your availability in a DRBD cluster setup. (Closes: #576511)
  * Added recommends to mailx (Closes: #691225)

 -- Philipp Hug <debian@hug.cx>  Mon, 29 Oct 2012 13:45:51 +0100

drbd8 (2:8.3.13-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix name of udev rules file. (closes: #679266)
  * Disable module version warning for sublevel missmatch.
    (closes: #659353)
  * Disable regeneration of buildtags file. (closes: #679460)

 -- Bastian Blank <waldi@debian.org>  Thu, 28 Jun 2012 21:07:04 +0000

drbd8 (2:8.3.13-1) unstable; urgency=low

  * Update to latest version for Linux 3.2.0
  * Enabled hardened build flags. Thanks Moritz. (Closes: #667558)

 -- Philipp Hug <debian@hug.cx>  Fri, 15 Jun 2012 20:14:36 +0200

=== debian/control ===
--- 
+++ 
@@ -17,6 +17,7 @@
 Provides: drbd-utils
 Replaces: drbd-utils, drbd
 Suggests: heartbeat
+Recommends: heirloom-mailx|mailx
 Description: RAID 1 over tcp/ip for Linux utilities
  Drbd is a block device which is designed to build high availability
  clusters by providing a virtual shared device which keeps disks in

=== debian/rules ===
--- 
+++ 
@@ -19,13 +19,11 @@
 -include $(MA_DIR)/include/generic.make
 -include $(MA_DIR)/include/common-rules.make
 
-CFLAGS = -Wall -g
+CFLAGS = `dpkg-buildflags --get CFLAGS`
+CFLAGS += -Wall
+CFLAGS += `dpkg-buildflags --get CPPFLAGS`
+LDFLAGS = `dpkg-buildflags --get LDFLAGS`
 
-ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
-	CFLAGS += -O0
-else
-	CFLAGS += -O2
-endif
 ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
 	INSTALL_PROGRAM += -s
 endif
@@ -76,7 +74,7 @@
 
 configure: configure-stamp
 configure-stamp:
-	./configure --prefix=/usr --localstatedir=/var --sysconfdir=/etc --with-utils --with-udev --with-xen --with-pacemaker --with-rgmanager --with-bashcompletion
+	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="$(LDFLAGS)" ./configure --prefix=/usr --localstatedir=/var --sysconfdir=/etc --with-utils --with-udev --with-xen --with-pacemaker --with-rgmanager --with-bashcompletion
 
 build: configure build-arch

## drbd8 8.4.3

=== drbd/Makefile ===
--- 
+++ 
@@ -46,22 +46,9 @@
  endif
 
   CONFIG_BLK_DEV_DRBD := m
-  CONFIG_DRBD_TRACE := n
 
-  include $(src)/Makefile-2.6
+  include $(src)/Kbuild
 
-  # remember KERNELRELEASE for install target
-  # .kernelversion can be included in Makefile as well as
-  # sourced from shell
-  $(shell echo -e "VERSION=$(VERSION)\n"             \
-                  "PATCHLEVEL=$(PATCHLEVEL)\n"       \
-                  "SUBLEVEL=$(SUBLEVEL)\n"           \
-                  "EXTRAVERSION=$(EXTRAVERSION)\n"   \
-                  "LOCALVERSION=$(LOCALVERSION)\n"   \
-                  "KERNELRELEASE=$(KERNELRELEASE)\n" \
-                  "KERNELVERSION=$(KERNELVERSION)"   \
-          > $(src)/.drbd_kernelrelease.new       \
-   )
 else
   # called from command line in current directory
 
@@ -134,8 +121,6 @@
 
   kbuild: drbd_buildtag.c
 	@rm -f .drbd_kernelrelease*
-	-test -f ../scripts/adjust_drbd_config_h.sh && \
-		KDIR=$(KDIR) O=$(O) $(SHELL) ../scripts/adjust_drbd_config_h.sh
     # previous to 2.6.6 (suse: 2.6.5-dunno), this should be:
 	$(MAKE) -C $(KDIR)  $(if $(O),O=$(O),) SUBDIRS=$(DRBDSRC) $(ARCH_UM) modules
 # $(MAKE) -C $(KDIR) M=$(DRBDSRC) $(ARCH_UM) modules
@@ -159,6 +144,7 @@
   clean:
 	rm -rf .tmp_versions Module.markers Module.symvers modules.order
 	rm -f *.[oas] *.ko .*.cmd .*.d .*.tmp *.mod.c .*.flags .depend .kernel*
+	rm -f compat/*.[oas] compat/.*.cmd
 
   distclean: clean
 	@if git show HEAD:drbd/linux/drbd_config.h > linux/drbd_config.h.tmp \

=== debian/changelog ===
drbd8 (2:8.4.3-0ubuntu0.12.04.2) precise-proposed; urgency=low

  * d/p/ubuntu-fix-drbdsetup-legacy-path.patch
    Test kernel module version and run the legacy drbdsetup early if
    it is lower than 8.4. Also do not try to be smart about paths for
    the legacy command (newer upstream versions do the same) (LP: #1314289).
  * d/p/ubuntu-compat83-init-script.patch:
    Fix service stop to shut down the resources (LP: #1314289).
  * d/p/ubuntu-compat83-ocf-script.patch:
    Fix pacemaker/corosync startup when running compat mode (LP: #1314289).
  * d/p/ubuntu-fix-drbdadm-version-check.patch:
    Fix compat mode when DRBD_DONT_WARN_ON_VERSION_MISMATCH is set
    (LP: #1314598)
  * d/rules: Create soft-links for compat binaries in /sbin to work
    around the tools looking for compat binaries in their own path
    when called with full path (LP: #1314289).

 -- Stefan Bader <stefan.bader@canonical.com>  Wed, 30 Apr 2014 15:20:23 +0200

drbd8 (2:8.4.3-0ubuntu0.12.04.1) precise; urgency=low

  * Backport version from 13.04 so that the utils will handle the
    changed in-kernel drbd module from the LTS Raring kernel
    (LP: #1185756).
  * Activate legacy command support by adding --with-legacy_utils to
    debian/rules.
  * Comment out "options" section in global_common.conf as testing
    showed problems in the backport.
  * Forward port the adjust_with_progress shell function from older
    versions of the utils and add the path to legacy utils to PATH.
  * Adjust legacy version to 8.3.11 as the code looks to be at least
    that version or later.

 -- Stefan Bader <stefan.bader@canonical.com>  Sat, 21 Sep 2013 18:40:51 -0500

drbd8 (2:8.4.3-0ubuntu1) raring; urgency=low

  * New upstream release.
    - Works against 3.8 kernel (LP: #1132302).
  * Dropped patches:
    - 0001-init-interactive-debian-613654.patch: applied upstream.
    - disable-default-handlers: all default handlers now appear to ship
      disabled from upstream.

 -- Robie Basak <robie.basak@canonical.com>  Tue, 26 Feb 2013 13:24:44 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: drbd8
 Section: admin
 Priority: extra
-Maintainer: Debian DRBD Maintainers <debian-ha-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian DRBD Maintainers <debian-ha-maintainers@lists.alioth.debian.org>
 Uploaders: Norbert Tretkowski <norbert@tretkowski.de>, Martin Loschwitz <madkiss@debian.org>, Philipp Hug <debian@hug.cx>
 Build-Depends: debhelper (>= 5), debconf-utils, bison, flex, bzip2, xsltproc, git
 Standards-Version: 3.9.1

=== debian/rules ===
--- 
+++ 
@@ -74,7 +74,7 @@
 
 configure: configure-stamp
 configure-stamp:
-	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="$(LDFLAGS)" ./configure --prefix=/usr --localstatedir=/var --sysconfdir=/etc --with-utils --with-udev --with-xen --with-pacemaker --with-rgmanager --with-bashcompletion
+	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="$(LDFLAGS)" ./configure --prefix=/usr --localstatedir=/var --sysconfdir=/etc --with-utils --with-udev --with-xen --with-pacemaker --with-rgmanager --with-bashcompletion --with-legacy_utils
 
 build: configure build-arch
 
@@ -114,6 +114,14 @@
 
 	$(MAKE) DESTDIR=$(CURDIR)/debian/drbd8-utils/ install
 	dh_install --source=debian/drbd8-utils --list-missing -s
+
+	# Create soft-links for the compat binaries to work around commands
+	# searching for the same path only for compat binaries when called
+	# with a full path.
+	ln -s ../lib/drbd/drbdadm-83 \
+		$(CURDIR)/debian/drbd8-utils/sbin/drbdadm-83
+	ln -s ../lib/drbd/drbdsetup-83 \
+		$(CURDIR)/debian/drbd8-utils/sbin/drbdsetup-83
 
 	# Move udev rule to /lib/udev/rules.d (Fixes lintian warning)
 	mkdir -p $(CURDIR)/debian/drbd8-utils/lib/udev/

=== debian/watch ===
version=3
http://oss.linbit.com/drbd/ 8.4/drbd-(.*).tar.gz
